/************************************************
* CATCHINT - Show how to use PRVs and a faked	*
* argument list to access register values for	*
* an ISR routine.								*
*												*
* 900316 MCMason - The Cobb Group, Inc.			*
************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <dos.h>
#include <string.h>

void interrupt (far *OldInt60)(void);

void interrupt far NewInt60(int bp,int di,int si,
		int ds,int es,int dx,int cx,int bx,int ax,
		int ip,int cs,int fl)
	{
	int	AX, BX, CX, DX,	SI, DI, BP, SP, IP,
		CS, DS, ES, SS, FL;

	/* Use PRVs to get the register values */
	AX=_AX; BX=_BX; CX=_CX; DX=_DX;
	SI=_SI; DI=_DI; SP=_SP; DS=_DS;
	ES=_ES; SS=_SS; FL=_FLAGS;

	puts("\n\nUsing PRV's we get:");
	printf("AX=%04x BX=%04x CX=%04x DX=%04x ",
			AX,		BX,		CX,		DX);
	printf("SI=%04x DI=%04x BP=???? SP=????\n",
			SI,		DI);
	printf("CS=???? DS=%04x ES=%04x SS=%04x ",
					DS,		ES,		SS);
	printf("IP=???? FL=%04x\n",FL);

	/* Using the 'faked' argument list: */
	IP=ip; CS=cs; AX=ax; BX=bx; CX=cx; DX=dx;
	ES=es; DS=ds; FL=fl; BP=bp; DI=di; SI=si;

	puts("\n\nUsing faked argument list we get:");
	printf("AX=%04x BX=%04x CX=%04x DX=%04x ",
			AX,		BX,		CX,		DX);
	printf("SI=%04x DI=%04x BP=%04x SP=%04x\n",
			SI,		DI,		BP,		SP);
	printf("CS=%04x DS=%04x ES=%04x SS=%04x ",
			CS,		DS,		ES,		SS);
	printf("IP=%04x FL=%04x\n",IP,FL);
	}

void main(void)
	{
	union REGS r;
	struct SREGS s;

	/* Install the Interrupt 60 monitor routine	*/
	OldInt60 = getvect(0x60);
	setvect(0x60,NewInt60);

	/* Call interrupt 60 with some known numbers*/
	r.x.ax=0x1234; r.x.bx=0x2345; r.x.cx=0x3456;
	r.x.dx=0x4321; r.x.si=0x1357; r.x.di=0x7351;
	s.ds=0x9ac2; s.es=0xac13; s.cs=0xfabb;
	s.ss=_SS;

	puts("Call Int 60H with known register vals");
	int86x(0x60,&r,&r,&s);
	puts("Back from Int 60H");

	/* Remove the Interrupt 60 monitor routine	*/
	setvect(0x60,OldInt60);
	}
